var babelHelpers = require("./babelHelpers");
/**
 * @file melon/Breadcrumb
 * @author leon(ludafa@outlook.com)
 */

var React = require('react');
var cx = require('melon-classname').create('Breadcrumb');
var Item = require('./breadcrumb/Item');

var Breadcrumb = function Breadcrumb(props) {
    var children = props.children;
    var rest = babelHelpers.objectWithoutProperties(props, ['children']);

    return React.createElement(
        'div',
        babelHelpers.extends({}, rest, { className: cx(props).build() }),
        React.Children.map(children, (child, index) => {
            return child && child.type === Item ? React.cloneElement(child, {
                key: index,
                level: index
            }) : null;
        })
    );
};

Breadcrumb.Item = Item;

module.exports = Breadcrumb;