var babelHelpers = require("./babelHelpers");
/**
 * @file esui-react/Mask
 * @author cxtom<cxtom2010@gmail.com>
 */

var React = require('react');
var cx = require('melon-classname').create('Mask');
var PropTypes = React.PropTypes;

var Mask = React.createClass({
    displayName: 'Mask',

    getInitialState() {
        this.originalBodyOverflow = '';
        return {};
    },

    propTypes: {
        autoLockScrolling: PropTypes.bool,
        show: PropTypes.bool
    },

    getDefaultProps() {
        return {
            autoLockScrolling: true
        };
    },

    componentDidMount() {
        this.originalBodyOverflow = document.getElementsByTagName('body')[0].style.oveflow;
    },

    componentDidUpdate() {
        var _props = this.props;
        var autoLockScrolling = _props.autoLockScrolling;
        var show = _props.show;

        if (!autoLockScrolling) {
            return;
        }

        show ? this.preventScrolling() : this.allowScrolling();
    },

    componentWillUnmount() {
        this.allowScrolling();
    },

    preventScrolling() {
        var body = document.getElementsByTagName('body')[0];
        body.style.overflow = 'hidden';
    },

    allowScrolling() {
        var body = document.getElementsByTagName('body')[0];
        body.style.overflow = this.originalBodyOverflow || '';
    },

    render() {
        var props = this.props;
        var show = props.show;

        return React.createElement('div', babelHelpers.extends({}, props, { className: cx(props).addStates({ show }).build() }));
    }

});

module.exports = Mask;