var babelHelpers = require("../babelHelpers");
/**
 * @file melon/dialog/Alert
 * @author cxtom(cxtom2010@gmail.com)
 */

var React = require('react');
var Dialog = require('../Dialog');
var Button = require('../Button');
var cx = require('melon-classname').create('Alert');

var Alert = React.createClass({

    displayName: 'Alert',

    propTypes: babelHelpers.extends({}, Dialog.propTypes, {
        buttonVariants: React.PropTypes.arrayOf(React.PropTypes.string)
    }),

    getDefaultProps: function () {
        return babelHelpers.extends({}, Dialog.defaultProps, {
            maskClickClose: false,
            title: null,
            buttonVariants: ['primary']
        });
    },

    onAlertSubmit() {
        var onHide = this.props.onHide;

        onHide();
    },

    renderAction() {
        var _props = this.props;
        var buttonVariants = _props.buttonVariants;
        var size = _props.size;

        return React.createElement(
            'div',
            { className: cx().part('actions').build() },
            React.createElement(Button, {
                label: '确定',
                key: 'submit',
                size: size,
                type: 'button',
                onClick: this.onAlertSubmit,
                variants: buttonVariants })
        );
    },

    render() {
        var _props2 = this.props;
        var variants = _props2.variants;
        var rest = babelHelpers.objectWithoutProperties(_props2, ['variants']);

        return React.createElement(Dialog, babelHelpers.extends({}, rest, {
            actions: this.renderAction(),
            variants: [].concat(babelHelpers.toConsumableArray(variants || []), ['alert']) }));
    }

});

module.exports = Alert;